// スクロール無効化
function scrollOff() {
  var scrollTop = jQuery(window).scrollTop();
  jQuery('body').addClass('scroll-off scroll-smooth').css('top', -scrollTop).attr('top', -scrollTop);
}
// スクロール無効化解除
function scrollOn() {
  var scrollTop = jQuery('body').attr('top');
  jQuery('body').removeClass('scroll-off').css('top', '');
  jQuery(window).scrollTop(-scrollTop);
  setTimeout(function(){
    jQuery('body').removeClass('scroll-smooth');
  },100)
}
function scrollOn_modal() {
  var scrollTop = jQuery('body').attr('top');
  jQuery('body').removeClass('scroll-off').css('top', '');
  jQuery(window).scrollTop(-scrollTop);
  setTimeout(function(){
    jQuery('body').removeClass('scroll-smooth');
  },500)
}

// Product Features
function scrollX() {
  jQuery('.js-scroll-x-wrap').each(function(){
    const scroll_container = jQuery(this)
    const scroll_elm = jQuery(this).find('.js-scroll-x-in')

    gsap.to(scroll_elm[0], {
      x: () => -(scroll_elm[0].scrollWidth - window.innerWidth),
      ease: "power1.inOut",
      scrollTrigger: {
        trigger: scroll_container[0],
        start: "bottom bottom",
        end: () => `+=${scroll_elm[0].scrollWidth}`,
        pin: true,
        // scrub: true,
        scrub: 1,
        pinSpacing: true,
      }
    });
  })
}

jQuery(function() {

  // ページ読み込み完了までリンク無効化
  jQuery('.js-nav-conts a').css('pointer-events','none')

  // ナビ
  jQuery('.js-nav-btn').click(function(e) {
    jQuery('body').toggleClass('scroll-smooth');
    e.preventDefault();
    jQuery(this).toggleClass('is-open');
    jQuery('.js-nav-conts').fadeToggle();
    // SP時
    const isSP = window.matchMedia('(max-width: 767px)').matches;
    if( isSP ) {
      if ( jQuery('body').hasClass('scroll-off')) {
        scrollOn();
      } else {
        scrollOff();
      }
    }
    // スムーススクロール
    jQuery('.js-nav-conts a').on( 'click',function (event) {
      event.preventDefault();
      const speed = 400;
      const href = jQuery(this).attr('href');
      const target = jQuery(href === '#' || href === '' ? 'html' : href);
      const targetStyle = target.css('transform');
      let scrollTop = 0;
      scrollOn_modal();

      if (target.length) {

        if (targetStyle === 'matrix(1, 0, 0, 1, 0, 0)') {
          // 要素　fadein後
          scrollTop = target.offset().top;
        } else {
          // 要素　fadein前
          scrollTop = target.offset().top - 50;
        }
        jQuery('body,html').animate(
          {
            scrollTop
          },
          speed,
          'swing'
        );
      }
      jQuery('.js-nav-btn').removeClass('is-open');
      jQuery('.js-nav-conts').fadeOut();
    });
  })
  // モーダル
  jQuery('.js-modal-trigger').click(function(e) {
    e.preventDefault();
    scrollOff()
    const target = jQuery(this).attr('href')
    // const target = trigger.next('.js-modal-target')
    jQuery(target).fadeIn()
    jQuery('.js-overlay').fadeIn()

    jQuery('.js-overlay, .js-close').click(function() {
      scrollOn()
      jQuery(target).fadeOut()
      jQuery('.js-overlay').fadeOut()
    })
  })
  // スライダー
  jQuery('.js-works-slider').each(function() {
    jQuery(this).slick({
      fade: true,
      infinite: true,
      // autoplay: true,
      autoplaySpeed: 5000,
      dots: true,
      arrows: false,
      pauseOnHover: false,
      pauseOnFocus: false,
      pauseOnDotsHover: false,
      customPaging: function(slider, i) {
        const labels = ['作品1', '作品2', '作品3'];
        return `${labels[i]}`;
      },
      responsive: [{
        breakpoint: 767,
        settings: {
          fade: false,
          customPaging: function(slider, i) {
            const labels = ['', '', ''];
            return `${labels[i]}`;
          },
        }
      }]
    });
  })

  // ギャラリー
  jQuery('.js-gallery-slider').slick({
    infinite: true,
    // autoplay: true,
    autoplaySpeed: 5000,
    dots: false,
    arrows: true,
    pauseOnHover: false,
    pauseOnFocus: false,
    pauseOnDotsHover: false,
  });
  jQuery('.fz30-special-gallery__slider-item').each(function() {
    const slide_img = jQuery(this).find('img')
    slide_img.on('load', function() {
      const originalWidth = this.naturalWidth;
      const originalHeight = this.naturalHeight;
      if (originalHeight > originalWidth) {
        const spanWidth = originalWidth / originalHeight * 100 + "%";
        slide_img.next('span').css({
          'width': spanWidth,
          'margin-inline': 'auto',
        });
      }
    });
  })
  jQuery('.js-gallery-trigger li').click(function(e) {
    e.preventDefault();
    scrollOff()
    const gallery_img = jQuery(this).find('img').attr('src')
    jQuery('.js-gallery-slider img').each(function (index) {
      if (jQuery(this).attr('src') === gallery_img) {
        jQuery('.js-gallery-slider').slick('slickGoTo', index - 1);
        return false;
      }
    });

    jQuery('.js-overlay').fadeIn()
    jQuery('.js-gallery-modal').fadeIn()

    jQuery('.js-overlay, .js-close').click(function() {
      jQuery('.js-gallery-modal').fadeOut()
      jQuery('.js-overlay').fadeOut()
      scrollOn()
    })
  })

  // 要素フェードイン
  const isPC = window.matchMedia('(min-width: 768px)').matches;
  const targetOffset = isPC ? '300px bottom' : '0 bottom';
  const options = {
    defaults: {
      duration: 1,
      ease: 'power1.out'
    }
  };
  let positionY = 100
  if( isPC ) {
    positionY = 100
  } else {
    positionY = 50
  }
  gsap.utils.toArray('[data-fadein]').forEach(function (element) {
    var elm = jQuery(element);
    var target = gsap.timeline({
      repeat: 0,
      defaults: options.defaults,
      scrollTrigger: {
        trigger: elm,
        start: targetOffset,
      }
    });
    target.fromTo(elm, {
      y: positionY,
      opacity: 0
    }, {
      y: 0,
      opacity: 1
    });
  });

  jQuery('img:not([loading="lazy"])').each(function () {
    if (this.complete) {
        jQuery(this).trigger('load');
    }
  }).on('load', function () {
    // lazy属性がない画像の読み込み完了後に実行
    // ページ読み込み完了後、リンク有効化
    jQuery('.js-nav-conts a').css('pointer-events','auto')
    scrollX()
  });

})



jQuery(window).on("scroll", function() {

  jQuery('[data-opacity]').each(function () {
    const sectionTop = jQuery(this).offset().top;
    const scrollPosition = jQuery(window).scrollTop();
    const windowHeight = jQuery(window).height();

    if (scrollPosition + windowHeight > sectionTop + 100) {
      jQuery(this).css('opacity', '1');
    }
  });

  // タイトル固定
  // SP時
  const isPC = window.matchMedia('(min-width: 768px)').matches;
  if (isPC) {
    jQuery(".js-fix-parents").each(function() {
      const fixParent = jQuery(this);
      const fixTtl = fixParent.find('.js-fix-elm');
      const elementTop = fixParent.offset().top;
      const elementHeight = fixParent.innerHeight();
      const scrollTop = jQuery(window).scrollTop();

      if (scrollTop >= elementTop && scrollTop <= elementTop + elementHeight - fixTtl.outerHeight()) {
        // 親要素内で固定
        fixTtl.css({
          'position': 'fixed',
          'top': '0', // 画面上部に固定
        });
      } else if (scrollTop > elementTop + elementHeight - fixTtl.outerHeight()) {
        // 固定解除後、親要素の最下部に配置
        fixTtl.css({
          'position': 'absolute',
          'top': elementHeight - fixTtl.outerHeight() + 'px',
        });
      } else {
        // 初期状態（スクロール前）
        fixTtl.css({
          'position': 'absolute',
          'top': '0',
        });
      }
    });
  }
});

jQuery(window).on('resize', function() {
  scrollX()
});
